# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 api_key: pulumi.Input[str],
                 api_retry_count: Optional[pulumi.Input[int]] = None,
                 api_retry_wait_max: Optional[pulumi.Input[int]] = None,
                 api_retry_wait_min: Optional[pulumi.Input[int]] = None,
                 api_url: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Provider resource.
        """
        pulumi.set(__self__, "api_key", api_key)
        if api_retry_count is not None:
            pulumi.set(__self__, "api_retry_count", api_retry_count)
        if api_retry_wait_max is not None:
            pulumi.set(__self__, "api_retry_wait_max", api_retry_wait_max)
        if api_retry_wait_min is not None:
            pulumi.set(__self__, "api_retry_wait_min", api_retry_wait_min)
        if api_url is None:
            api_url = _utilities.get_env('OPSGENIE_API_URL')
        if api_url is not None:
            pulumi.set(__self__, "api_url", api_url)

    @property
    @pulumi.getter(name="apiKey")
    def api_key(self) -> pulumi.Input[str]:
        return pulumi.get(self, "api_key")

    @api_key.setter
    def api_key(self, value: pulumi.Input[str]):
        pulumi.set(self, "api_key", value)

    @property
    @pulumi.getter(name="apiRetryCount")
    def api_retry_count(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "api_retry_count")

    @api_retry_count.setter
    def api_retry_count(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "api_retry_count", value)

    @property
    @pulumi.getter(name="apiRetryWaitMax")
    def api_retry_wait_max(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "api_retry_wait_max")

    @api_retry_wait_max.setter
    def api_retry_wait_max(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "api_retry_wait_max", value)

    @property
    @pulumi.getter(name="apiRetryWaitMin")
    def api_retry_wait_min(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "api_retry_wait_min")

    @api_retry_wait_min.setter
    def api_retry_wait_min(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "api_retry_wait_min", value)

    @property
    @pulumi.getter(name="apiUrl")
    def api_url(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "api_url")

    @api_url.setter
    def api_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_url", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_key: Optional[pulumi.Input[str]] = None,
                 api_retry_count: Optional[pulumi.Input[int]] = None,
                 api_retry_wait_max: Optional[pulumi.Input[int]] = None,
                 api_retry_wait_min: Optional[pulumi.Input[int]] = None,
                 api_url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The provider type for the opsgenie package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProviderArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the opsgenie package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_key: Optional[pulumi.Input[str]] = None,
                 api_retry_count: Optional[pulumi.Input[int]] = None,
                 api_retry_wait_max: Optional[pulumi.Input[int]] = None,
                 api_retry_wait_min: Optional[pulumi.Input[int]] = None,
                 api_url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            if api_key is None and not opts.urn:
                raise TypeError("Missing required property 'api_key'")
            __props__.__dict__["api_key"] = api_key
            __props__.__dict__["api_retry_count"] = pulumi.Output.from_input(api_retry_count).apply(pulumi.runtime.to_json) if api_retry_count is not None else None
            __props__.__dict__["api_retry_wait_max"] = pulumi.Output.from_input(api_retry_wait_max).apply(pulumi.runtime.to_json) if api_retry_wait_max is not None else None
            __props__.__dict__["api_retry_wait_min"] = pulumi.Output.from_input(api_retry_wait_min).apply(pulumi.runtime.to_json) if api_retry_wait_min is not None else None
            if api_url is None:
                api_url = _utilities.get_env('OPSGENIE_API_URL')
            __props__.__dict__["api_url"] = api_url
        super(Provider, __self__).__init__(
            'opsgenie',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter(name="apiKey")
    def api_key(self) -> pulumi.Output[str]:
        return pulumi.get(self, "api_key")

    @property
    @pulumi.getter(name="apiUrl")
    def api_url(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "api_url")

